﻿{
  "Logging": {
    "Diagnostic": {
      "Enable": true,
      "RealIpHeader": "X-Client-IP",
      "ContentTypesForResponseBodyLogging": [ "text/plain", "application/json" ]
    },
    "Using": [ "Serilog.Sinks.Console" ],
    "MinimumLevel": {
      "Default": "Debug",
      "Override": {
        "System": "Warning",
        "Microsoft": "Warning",
        "Microsoft.AspNetCore.Hosting.Internal.WebHost": "Warning",
        "LVDGW.Core.Middlewares.EnrichmentMiddleware": "Warning",
        "LVDGW.Core.Middlewares.DiagnosticLogMiddleware": "Warning"
      }
    },
    "WriteTo": [
      {
        "Name": "Console",
        "Args": {
          "theme": "Serilog.Sinks.SystemConsole.Themes.AnsiConsoleTheme::Code, Serilog.Sinks.Console",
          "outputTemplate": "[{Timestamp:HH:mm:ss} {Level:u3}] {SourceContext} [{Properties}] {NewLine} ## {Message:lj}{NewLine}{Exception}"
        }
      },
      {
        "Name": "Async",
        "Args": {
          "configure": [
            {
              "Name": "File",
              "Args": {
                "restrictedToMinimumLevel": "Debug",
                "path": "/logs/lds-lvdgw-core-%HOSTNAME%-.log", //%TEMP% %APPDATA%
                "rollingInterval": "Day",
                "retainedFileCountLimit": 5,
                "rollOnFileSizeLimit": true,
                "fileSizeLimitBytes": 104857600, // 104857600: 100MB
                "outputTemplate": "{Timestamp:yyyy-MM-dd HH:mm:ss.fff zzz} [{Level:u3}] {SourceContext} [{Properties}] {NewLine} ## {Message:lj}{NewLine}{Exception}",
                "shared": false,
                "buffered": false // handle buffering in Async wrapper
                //"flushToDiskInterval": "0.00:00:10.000", //d.hh.mm.ss.MM
              }
            }
          ],
          "bufferSize": 500,
          "blockWhenFull": true
        }
      }
      //,{
      //  "Name": "Elasticsearch",
      //  "Args": {
      //    "nodeUris": "http://elasticsearch:9200",
      //    "indexFormat": "lds-lvdgw-core-{0:yyyy.MM.dd}",
      //    "autoRegisterTemplate": true,
      //    "autoRegisterTemplateVersion": "ESv6",
      //    "templateName": "lds-lvdgw-core-log-template",
      //    "inlineFields": true,
      //    "minimumLogEventLevel": "Warning",
      //    "bufferBaseFilename": "/logs/buffer/elastic-buffer",
      //    "bufferFileSizeLimitBytes": 104857600, // 104857600: 100MB
      //    "bufferLogShippingInterval": 5000
      //  }
      //}
    ],
    "Enrich": [ "FromLogContext", "WithMachineName", "WithThreadId", "WithProcessId", "WithProcessName" ],
    "Properties": {
      "Application": "LDS.LVDGW.Core"
    }
  },
  "Plugins": [
    {
      "Name": "ResponseWrapperPlugin",
      "Nuget": {
        "Name": "LDS.LVDGW.Plugin.ResponseWrapper",
        "Version": "1.0.1",
        "AssemblyName": "LDS.LVDGW.Plugin.ResponseWrapper",
        //"Source": "https://api.nuget.org/v3/index.json",
        "Source": "local-plugin-packages"
      },
      "Parameters": {
        "WrappableContentTypes": "text/plain;application/json",
        "PropertyNameHttpStatus": "httpStatus",
        "PropertyNameHttpStatusCode": "code",
        "PropertyNameHttpStatusCodeDescription": "description",
        "PropertyNameHttpStatusIsSuccess": "success",
        "PropertyNameServerTime": "serverTimeUTCInSeconds",
        "PropertyNameData": "data"
      }
    },
    {
      "Name": "IPInfoEnrichmentPlugin",
      "Nuget": {
        "Name": "LDS.LVDGW.Plugin.IPInfoEnrichment",
        "Version": "1.0.0",
        "AssemblyName": "LDS.LVDGW.Plugin.IPInfoEnrichment",
        "Source": "local-plugin-packages"
      },
      "Parameters": {
        "ReadIPFromHeader": "X-Real-IP",
        "Container": "Header", // Header,Form,Query
        "Prefix": "X-IPINFO-"
      }
    },
    {
      "Name": "ConfigurationMicroservicePlugin",
      "Nuget": {
        "Name": "LDS.LVDGW.Plugin.ConfigurationMicroservice",
        "Version": "1.0.1",
        "AssemblyName": "LDS.LVDGW.Plugin.ConfigurationMicroservice",
        "Source": "local-plugin-packages"
      },
      "Parameters": {
        "ConfigurationFilesPath": "/config/lvdgw/configuration-microservice/",
        "PathPrefix": "/api/configuration/",
        "UseJsonBuilder": false
      }
    },
    {
      "Name": "JWTAuthenticationPlugin",
      "Nuget": {
        "Name": "LDS.LVDGW.Plugin.JWTAuthentication",
        "Version": "1.0.0",
        "AssemblyName": "LDS.LVDGW.Plugin.JWTAuthentication",
        "Source": "local-plugin-packages"
      },
      "Parameters": {
        "JWTSecret": "<secret>"
      }
    },
    {
      "Name": "AuthenticationMicroservicePlugin",
      "Nuget": {
        "Name": "LDS.LVDGW.Plugin.AuthenticationMicroservice",
        "Version": "1.0.0",
        "AssemblyName": "LDS.LVDGW.Plugin.AuthenticationMicroservice",
        "Source": "local-plugin-packages"
      },
      "Parameters": {
        "ConnectionString": "<secret>",
        "PathPrefix": "/api/identity/",
        //"CallbackUri": "http://192.168.0.174:8092/api/account",
        "CallbackUri": "http://nebula.loodos.com/api/account",
        //"CallbackUri": "http://docker-container-name/api/account",
        "CallbackDataContainer": "Form", // Header, Form, Query
        "CallbackDataHeaderPrefix": "X-IDENT-",
        "BaseUri": "http://localhost:8088",
        "ErrorMessageSeperator": "/n",
        "UseEmailAsUsername": true,
        "Identity_Lockout_Enabled": true,
        "Identity_Lockout_AllowedForNewUsers": true,
        "Identity_Lockout_MaxFailedAccessAttempts": 5,
        "Identity_Lockout_DefaultLockoutTimeSpan": "0.00:05:00.000", //d.hh.mm.ss.MM
        "Identity_Password_RequireDigit": true,
        "Identity_Password_RequireLowercase": false,
        "Identity_Password_RequireNonAlphanumeric": false,
        "Identity_Password_RequireUppercase": false,
        "Identity_Password_RequiredLength": 8,
        "Identity_Password_RequiredUniqueChars": 1,
        "Identity_SignIn_RequireConfirmedEmail": false,
        "Identity_SignIn_RequireConfirmedPhoneNumber": false,
        "Identity_Register_EmailConfirmUri": "/cdn/staticHtml/{culture}/ConfirmEmail.html",
        "Identity_ConfirmResetPassword": "/cdn/staticHtml/{culture}/ConfirmResetPassword.html",
        "Identity_User_AllowedUserNameCharacters": "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-._@+",
        "Identity_MailTemplatesPath": "/config/lvdgw/authentication-microservice/mailtemplates/{culture}/",
        "Identity_User_RequireUniqueEmail": false, // because username is email
        "Identity_Username_RequiredLength": 6,
        "Identity_UploadBasePath": "uploads",
        "Identity_Token_UseTOTP": true,
        "Identity_Token_TOTP_Step": 86400, // a new code will be generated every 900 seconds (5 minutes)
        "Identity_Token_TOTP_Size": 6, // 6 digits
        "Identity_Token_TOTP_SecurityHash": "D64,kXpW^)v-GmQxiJ4VH]zV*b$sQU",
        "Identity_Facebook_AppId": "312184436232308",
        "Identity_Facebook_AppSecret": "cc8481f7b79dace15b6e5941dc1045ff",
        "Identity_Facebook_RequiredFields": "id,email,name,birthday,picture",
        "Identity_Facebook_RequiredFields_Musts": "id,email,name",
        "JWTIssuer": "LVDGW",
        "JWTAudience": "http://lvdgw.com/",
        "JWTSecret": "<secret>",
        "JWTValidFor": "0.02:00:00.000", //d.hh.mm.ss.MM
        "Smtp_Server": "smtp.gmail.com",
        "Smtp_Port": 587,
        "Smtp_Username": "noreply@loodos.com",
        "Smtp_Pass": "123456.x",
        "Smtp_From": "noreply@loodos.com",
        "Smtp_FromName": "IKSV Authentication Service",
        "Firebase_DynamicLinks_Use": true,
        "Firebase_DynamicLinks_UseInRegister": false,
        "Firebase_DynamicLinks_WebApiKey": "AIzaSyAvTpRB9Z57AW6kWyXu3yk1FsdxZWeMTMo",
        "Firebase_DynamicLinks_Domain": "iksvtest.page.link",
        "Firebase_DynamicLinks_Android_APN": "com.example.android",
        "Firebase_DynamicLinks_iOS_IBI": "com.example.ios"
        //"Smtp_Server": "mail.example.com",
        //"Smtp_Port": 25,
        //"Smtp_Username": "noreply@vanilla.com",
        //"Smtp_Pass": "smtp_pass",
        //"Smtp_From": "noreply@vanilla.com",
        //"Smtp_FromName": "Vanilla Authentication Service"
      }
    },
    {
      "Name": "ForceUpdateMicroservicePlugin",
      "Nuget": {
        "Name": "LDS.LVDGW.Plugin.ForceUpdateMicroservice",
        "Version": "1.0.0",
        "AssemblyName": "LDS.LVDGW.Plugin.ForceUpdateMicroservice",
        "Source": "local-plugin-packages"
      },
      "Parameters": {
        "RulesFilePath": "/config/lvdgw/forceupdate-microservice/forceUpdateRules.json",
        "Container": "Header", // Header,Form,Query
        "ContainerKey_Platform": "X-Platform", // iOS, Android
        "ContainerKey_PlatformVersion": "X-PlatformVersion", // 1.0.0
        "ContainerKey_AppVersion": "X-AppVersion", // 1.0.0
        "StoreUrl_Android": "http://play.google.com/store/apps/details?id=<package_name>", // 1.0.0
        "StoreUrl_iOS": "https://itunes.apple.com/app/id<app_id>"
      }
    }
  ],
  "Cache": {
    "MemoryCache": {
      "Enable": false
    },
    "DistributedRedisCache": {
      "Enable": true,
      "Options": {
        "Configuration": "<secret>",
        "InstanceName": "LDS-LVDGW-CORE"
      }
    },
    "DistributedSqlServerCache": {
      "Enable": false,
      "Options": {
        "ConnectionString": "Data Source=(localdb)\\v11.0;Initial Catalog=DistCache;Integrated Security=True;",
        "SchemaName": "dbo",
        "TableName": "LDS-LVDGW-CORE-CACHE"
      }
    }
  },
  "RoutingEngine": {
    "TimeoutInSeconds": 20,
    "Routes": [
      {
        "Name": "jsonplaceholder-fake-route",
        "Template": "api/{*prm}",
        "Destination": "http://jsonplaceholder.typicode.com/{prm}",
        "Enable": true
      }
    ]
  },
  "ResponseCache": {
    "Enable": true,
    "CacheStore": "DistributedRedisCache", //MemoryCache, DistributedRedisCache, DistributedSqlServerCache
    "AcceptedVerbs": [ "GET", "POST", "HEAD" ],
    "AcceptedHeadersForHashKey": [ "x-app-key", "x-app-id", "x-token", "culture", "content-type", "x-platform", "x-appversion", "x-platformversion" ],
    "ExcludeHeaders": {
      "Cache-Control": "no-cache",
      "Authorization": ""
    },
    "DefaultExpiryInSeconds": 600,
    "EndpointRules": [
      {
        "Endpoint": "*:^/api/users/(.*)$",
        "ExpiryInSeconds": 3600,
        "NoCache": false
      },
      {
        "Endpoint": "*:^/api/posts/(.*)$",
        "NoCache": true
      }
    ]
  },
  "ResponseWrapper": {
    "Enable": true,
    "ContentType": "application/json",
    "ForceHttpStatus200OK": true,
    "Plugin": "ResponseWrapperPlugin"
  },
  "Enrichment": {
    "Plugins": [
      "IPInfoEnrichmentPlugin"
    ]
  },
  "Microservices": [
    {
      "Enable": true,
      "Endpoint": "GET:^/api/configuration/(.*)$",
      "Plugin": "ConfigurationMicroservicePlugin"
    },
    {
      "Enable": true,
      "Endpoint": "*:^/api/identity/(.*)$",
      "Plugin": "AuthenticationMicroservicePlugin"
    },
    {
      "Enable": true,
      "Endpoint": "*:^/api/checkupdate$",
      "Plugin": "ForceUpdateMicroservicePlugin"
    }
  ],
  "IPRestriciton": {
    "Enable": true,
    "ReadIPFromHeader": "X-Real-IP",
    "HttpStatusCode": 403,
    "RestrictionMessage": "You don't have permission to access! IP={0}",
    "EndpointPolicies": [
      {
        "Endpoint": "*:^/api/manage/(.*)$",
        // Deny all IPs expect Whitelist
        "Whitelist": [
          "192.168.0.0/24"
        ]
      },
      {
        "Endpoint": "*:^/api/content/(.*)$",
        // Allow all IPs expect Blacklist
        "Blacklist": [
          "192.168.0.100"
        ]
      }
    ],
    "IPPolicies": [
      {
        "IP": "192.168.0.111",
        // Deny all Endpoint expect Whitelist
        "Whitelist": [
          "*:^/api/static/(.*)$",
          "*:^/api/terms/(.*)$"
        ]
      },
      {
        "IP": "192.168.0.222",
        // Allow all Endpoint expect Blacklist
        "Blacklist": [
          "*:^/(.*)$"
        ]
      }
    ]
  },
  "AppAuthentication": {
    "Enable": true,
    "AppId": {
      "HeaderKey": "x-app-id",
      "FormKey": "appid",
      "QueryKey": "appid"
    },
    "AppKey": {
      "HeaderKey": "x-app-key",
      "FormKey": "appkey",
      "QueryKey": "appkey"
    },
    "Apps": [
      {
        "Enable": true,
        "AppId": "com.loodos.lvdgw.confirmemail",
        "AppKey": "R71m14lzOOUmTQnSz6vSP4asFqWXjGD9",
        "AcceptedEndpoints": [
          "^/api/identity/email/confirm$"
        ]
      },
      {
        "Enable": true,
        "AppId": "org.iksv.android.ldsdev", //android test appId(bundleid)
        "AppKey": "MiqbvrQDo3ro7DoV770Mbk9ST1OuVUh3",
        "AcceptedEndpoints": [
          "^/api/(.*)$"
        ]
      },
      {
        "Enable": true,
        "AppId": "com.loodos.lvdgw.client",
        "AppKey": "MiqbvrQDo3ro7DoV770Mbk9ST1OuVUh3",
        "AcceptedEndpoints": [
          "^/api/(.*)$"
        ]
      }
    ]
  },
  "UserAuthentication": {
    "Enable": true,
    "Token": {
      "Container": "Header", // Header,Form,Query
      "Key": "x-token"
    },
    "EnrichHttpContextUser": true,
    "EnrichRequest": {
      "Container": "Form", // Header,Form,Query
      "ContentType": "application/x-www-form-urlencoded",
      "Prefix": "X-LVDGW-"
    },
    "EndpointRules": [
      {
        "Endpoint": "*:^/api/comments/(.*)$",
        "ValidationOptional": false
      },
      {
        "Endpoint": "*:^/api/(.*)$",
        "ValidationOptional": true
      }
    ],
    "Plugin": "JWTAuthenticationPlugin"
  },
  "ConcurrentRequestsLimit": {
    "Enable": true,
    "Limit": 10,
    "LimitExceededPolicy": "Drop", // Drop, FifoQueueDropTail, FifoQueueDropHead
    "QueueSize": 10,
    "QueueTimeoutInSeconds": 30
  },
  "RateLimit": {
    "Enable": true,
    "CacheStore": "DistributedRedisCache", //MemoryCache, DistributedRedisCache, DistributedSqlServerCache
    "IpRateLimiting": {
      "Enable": true,
      "Options": {
        "EnableEndpointRateLimiting": true,
        "StackBlockedRequests": false,
        "RealIpHeader": "X-Client-IP",
        "ClientIdHeader": "X-LVDGW-Username",
        "HttpStatusCode": 429,
        "QuotaExceededMessage": "API calls quota exceeded! maximum admitted {0} per {1}",
        "DisableRateLimitHeaders": false,
        "IpWhitelist": [ "127.0.0.1", "192.168.0.0/24" ], //"::1/10",
        "EndpointWhitelist": [ "get:/api/license", "*:/api/status" ],
        "ClientWhitelist": [ "loodos", "lvdgw" ],
        "GeneralRules": [
          {
            "Endpoint": "*",
            "Period": "1s",
            "Limit": 1
          },
          {
            "Endpoint": "*",
            "Period": "1m",
            "Limit": 20
          },
          {
            "Endpoint": "*",
            "Period": "15m",
            "Limit": 100
          },
          {
            "Endpoint": "*",
            "Period": "12h",
            "Limit": 1000
          },
          {
            "Endpoint": "*",
            "Period": "7d",
            "Limit": 10000
          },
          {
            "Endpoint": "post:/api/authentication/*",
            "Period": "5m",
            "Limit": 3
          }
        ]
      },
      "Policies": {
        "IpRules": [
          {
            "Ip": "185.33.61.110",
            "Rules": [
              {
                "Endpoint": "*",
                "Period": "1s",
                "Limit": 10
              }
            ]
          }
        ]
      }
    },
    "ClientRateLimiting": {
      "Enable": true,
      "Options": {
        "EnableEndpointRateLimiting": true,
        "StackBlockedRequests": false,
        "ClientIdHeader": "X-LVDGW-Username",
        "HttpStatusCode": 429,
        "QuotaExceededMessage": "API calls quota exceeded! maximum admitted {0} per {1}",
        "DisableRateLimitHeaders": false,
        "EndpointWhitelist": [ "get:/api/license", "*:/api/status" ],
        "ClientWhitelist": [ "loodos", "lvdgw" ],
        "GeneralRules": [
          {
            "Endpoint": "*",
            "Period": "1s",
            "Limit": 2
          },
          {
            "Endpoint": "*",
            "Period": "1m",
            "Limit": 20
          },
          {
            "Endpoint": "*",
            "Period": "15m",
            "Limit": 100
          },
          {
            "Endpoint": "*",
            "Period": "12h",
            "Limit": 1000
          },
          {
            "Endpoint": "*",
            "Period": "7d",
            "Limit": 10000
          },
          {
            "Endpoint": "post:/api/authentication/*",
            "Period": "5m",
            "Limit": 3
          }
        ]
      },
      "Policies": {
        "ClientRules": [
          {
            "ClientId": "loodos-test",
            "Rules": [
              {
                "Endpoint": "*",
                "Period": "1s",
                "Limit": 10
              }
            ]
          }
        ]
      }
    }
  },
  "PublicFileServer": {
    "Enable": true,
    "RequestPath": "/cdn",
    "PhysicalPath": "wwwroot",
    "EnableDirectoryBrowsing": true,
    "ContentTypeMapping": {
      ".jpg": "image/jpeg",
      ".jpeg": "image/jpeg",
      ".png": "image/png",
      ".html": "text/html"
    },
    "Headers": {
      "Cache-Control": "public,max-age=600"
    }
  },
  "PrivateFileServer": {
    "Enable": true,
    "RequestPath": "/files",
    "PhysicalPath": "PrivateFileServer",
    "ContentTypeMapping": {
      ".jpg": "image/jpeg",
      ".jpeg": "image/jpeg",
      ".png": "image/png",
      ".pdf": "application/pdf"
    }
  },
  "MetricsMonitoring": {
    "Enable": false,
    "Port": 58348,
    "EnvironmentInfoEndpoint": "/env",
    "MetricsPrometheusEndpoint": "/metrics-prometheus",
    "MetricsJSONEndpoint": "/metrics-json",
    "ApdexTSeconds": 0.1,
    "IgnoredHttpStatusCodes": [],
    "IgnoredRoutesRegexPatterns": [],
    "ReportTo": {
      "Enable": false,
      "Console": {
        "FlushInterval": "0.00:00:02.000" //d.hh.mm.ss.MM
      }
      //"TextFile": {
      //  "FlushInterval": "0.00:00:02.000", //d.hh.mm.ss.MM
      //  "Append": false,
      //  "FilePath": "C:\\LoodosCodes\\lds-lvdgw\\lds-lvdgw-core\\LVDGW.Core\\metrics.txt"
      //}
    }
  },
  "Localization": {
    "Enable": true,
    "SupportedCultures": [ "tr-TR", "en-US" ],
    "DefaultCulture": "tr-TR",
    "JsonResourcesPath": "/config/lvdgw/json-resources/" // absolute path
    //"JsonResourcesPath": "json-resources" // relative path from executed assembly file
  }
}
